#include "stdafx.h"
#include "ImgProc.h"

CVisByteImage Gray644x484(unsigned char input[])
{
	CVisByteImage I;
	I.Allocate(644,484);

	for (int x = 0; x < 644; x++)
		for (int y = 0; y < 484; y++)
			I.Pixel(x,y) = input[x+y*644];

	return I;
}

CVisByteImage Gray322x242(unsigned char input[])
{
	CVisByteImage I;
	I.Allocate(322,242);

	for (int x = 0; x < 322; x++)
		for (int y = 0; y < 242; y++)
			I.Pixel(x,y)=(input[2*x+2*y*644]+input[2*x+(2*y+1)*644]+input[2*x+1+2*y*644]+input[2*x+1+(2*y+1)*644])/4;

	return I;
}

CVisRGBAByteImage Color644x484(unsigned char input[])
{
	CVisRGBAByteImage rgb;
	rgb.Allocate(644,484);

	int dx = 644;
	int dy = 484;

	int x,y;
	int hdiff,vdiff;

	// green interpolation
	for (y = 2; y < dy-2; y++)
		for (x = 2; x < dx-2; x++)
			if ((x%2)==(y%2))
			{
				hdiff=abs(((input[x-2+y*644]+input[x+2+y*644])/2)-input[x+y*644]);
				vdiff=abs(((input[x+(y-2)*644]+input[x+(y+2)*644])/2)-input[x+y*644]);
				if (hdiff<vdiff)
					rgb.Pixel(x,y).SetG((input[x-1+y*644]+input[x+1+y*644])/2);
				else if (vdiff<hdiff)
					rgb.Pixel(x,y).SetG((input[x+(y-1)*644]+input[x+(y+1)*644])/2);
				else
					rgb.Pixel(x,y).SetG((input[x-1+y*644]+input[x+1+y*644]+input[x+(y-1)*644]+input[x+(y+1)*644])/4);
			}
			else
				rgb.Pixel(x,y).SetG(input[x+y*644]);

	// red interpolation
	for (y = 2; y < dy-2; y += 2)
		for (x = 2; x < dx-2; x += 2)
		{
			rgb.Pixel(x  ,y  ).SetR( input[x+y*644]);
			rgb.Pixel(x+1,y  ).SetR(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+2+y*644]-rgb.Pixel(x+2,y  ).G())/2
															+rgb.Pixel(x+1,y  ).G())));
			rgb.Pixel(x  ,y+1).SetR(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+(y+2)*644]-rgb.Pixel(x  ,y+2).G())/2
															+rgb.Pixel(x  ,y+1).G())));
			rgb.Pixel(x+1,y+1).SetR(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+2+y*644]-rgb.Pixel(x+2,y  ).G()
															+input[x+(y+2)*644]-rgb.Pixel(x  ,y+2).G()
															+input[x+2+(y+2)*644]-rgb.Pixel(x+2,y+2).G())/4
															+rgb.Pixel(x+1,y+1).G())));
		}

	// blue interpolation
	for (y = 3; y < dy-1; y += 2)
		for (x = 3; x < dx-1; x += 2)
		{
			rgb.Pixel(x  ,y  ).SetB( input[x+y*644]);
			rgb.Pixel(x+1,y  ).SetB(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+2+y*644]-rgb.Pixel(x+2,y  ).G())/2
															+rgb.Pixel(x+1,y  ).G())));
			rgb.Pixel(x  ,y+1).SetB(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+(y+2)*644]-rgb.Pixel(x  ,y+2).G())/2
															+rgb.Pixel(x  ,y+1).G())));
			rgb.Pixel(x+1,y+1).SetB(min(255,max(0,
															(input[x+y*644]-rgb.Pixel(x  ,y  ).G()
															+input[x+2+y*644]-rgb.Pixel(x+2,y  ).G()
															+input[x+(y+2)*644]-rgb.Pixel(x  ,y+2).G()
															+input[x+2+(y+2)*644]-rgb.Pixel(x+2,y+2).G())/4
															+rgb.Pixel(x+1,y+1).G())));
		}

	for (x = 3; x < dx-1; x++)
		rgb.Pixel(x,dy-2).SetB(0);
	for (y = 3; y < dy-1; y++)
		rgb.Pixel(dx-2,y).SetB(0);
	return rgb;
}

CVisRGBAByteImage Color322x242(unsigned char input[])
{
	CVisRGBAByteImage rgb;
	rgb.Allocate(322,242);

	for (int x = 0; x < 322; x++)
		for (int y = 0; y < 242; y++)
		{
			rgb.Pixel(x,y).SetR(input[2*x+2*y*644]);
			rgb.Pixel(x,y).SetG((input[2*x+(2*y+1)*644]+input[2*x+1+2*y*644])/2);
			rgb.Pixel(x,y).SetB(input[2*x+1+(2*y+1)*644]);
		}

	return rgb;
}

CVisRGBAByteImage ColorBal644x484(unsigned char input[])
{
	CVisRGBAByteImage I = Color644x484(input);
	for (int x = 0; x < 644; x++)
		for (int y = 0; y < 484; y++)
		{
			I.Pixel(x,y).SetR(min(255,I.Pixel(x,y).R()*1.55));
			I.Pixel(x,y).SetG(min(255,I.Pixel(x,y).G()*1.40));
			I.Pixel(x,y).SetB(min(255,I.Pixel(x,y).B()*2.80));
		}
	return I;
}

CVisRGBAByteImage ColorBal322x242(unsigned char input[])
{
	CVisRGBAByteImage I = Color322x242(input);
	for (int x = 0; x < 322; x++)
		for (int y = 0; y < 242; y++)
		{
			I.Pixel(x,y).SetR(min(255,I.Pixel(x,y).R()*1.55));
			I.Pixel(x,y).SetG(min(255,I.Pixel(x,y).G()*1.40));
			I.Pixel(x,y).SetB(min(255,I.Pixel(x,y).B()*2.80));
		}
	return I;
}

int Contrast(unsigned char input[])
{
	CVisByteImage I=Gray322x242(input);

	long t = 0;
	long n = 0;
	for (int x = 100; x < 222; x++)
		for (int y = 80; y < 162; y++)
		{
			t+=abs(I.Pixel(x,y)-I.Pixel(x,y-1));
			t+=abs(I.Pixel(x,y)-I.Pixel(x,y+1));
			t+=abs(I.Pixel(x,y-1)-I.Pixel(x,y));
			t+=abs(I.Pixel(x,y+1)-I.Pixel(x,y));
			n+=I.Pixel(x,y);
		}

	return t;
}
