// KeckControllerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "KeckController.h"
#include "KeckControllerDlg.h"
#include "CamSelDlg.h"
#include "SeqSaveDlg.h"
#include "ImgProc.h"
#include "imapidef.h"
#include "direct.h"

#include "..\KeckServer\KeckServer_i.c"

#include <comdef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STRLEN 80        // string size for general text manipulation   
char str[STRLEN];        // global string for general text manipulation 

#define SHOW_ERROR(ecode) ::MessageBox(HWND_DESKTOP,olDaGetErrorString(ecode,\
                  str,STRLEN),"Error", MB_ICONEXCLAMATION | MB_OK);

#define CHECKERROR(ecode) if ((status = (ecode)) != OLNOERROR)\
                  {\
                  SHOW_ERROR(status);\
                  olDaReleaseDASS(ct_ss);\
                  olDaTerminate(hdrvr);\
                  return 0;}

#define CHECKERROR2(ecode) if ((status = (ecode)) != OLNOERROR)\
                  {\
                  SHOW_ERROR(status);\
                  olDaReleaseDASS(ct_ss);\
                  olDaTerminate(hdrvr);\
                  }

CKeckControllerDlg *theDlg;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeckControllerDlg dialog

CKeckControllerDlg::CKeckControllerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeckControllerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeckControllerDlg)
	m_FrameRate = 0;
	m_FrameCount = 0;
	m_PauseTime = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeckControllerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeckControllerDlg)
	DDX_Control(pDX, IDC_TRIGGER, m_TriggerBox);
	DDX_Control(pDX, IDC_SETTINGS, m_Settings);
	DDX_Control(pDX, IDC_FOCUS, m_Focus);
	DDX_Control(pDX, IDC_FRAME_COUNT, m_FrameCountEdit);
	DDX_Control(pDX, IDC_SAVE, m_Save);
	DDX_Control(pDX, IDC_PLAY, m_Play);
	DDX_Control(pDX, IDC_DISPLAY, m_Display);
	DDX_Control(pDX, IDC_CLOSE, m_Close);
	DDX_Control(pDX, IDC_RIG_LIST, m_RigList);
	DDX_Control(pDX, IDC_CAM_LIST, m_CamList);
	DDX_Control(pDX, IDC_MESSAGES, m_Messages);
	DDX_Control(pDX, IDC_CAPTURE, m_Capture);
	DDX_Text(pDX, IDC_FRAME_RATE, m_FrameRate);
	DDV_MinMaxUInt(pDX, m_FrameRate, 1, 60);
	DDX_Text(pDX, IDC_FRAME_COUNT, m_FrameCount);
	DDV_MinMaxUInt(pDX, m_FrameCount, 1, 9999);
	DDX_Text(pDX, IDC_PAUSE_TIME, m_PauseTime);
	DDV_MinMaxUInt(pDX, m_PauseTime, 0, 60);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeckControllerDlg, CDialog)
	//{{AFX_MSG_MAP(CKeckControllerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_EN_CHANGE(IDC_FRAME_RATE, OnChangeFrameRate)
	ON_BN_CLICKED(IDC_FOCUS, OnFocus)
	ON_BN_CLICKED(IDC_SETTINGS, OnSettings)
	ON_BN_CLICKED(IDC_TRIGGER, OnTrigger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeckControllerDlg message handlers

BOOL CKeckControllerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	theDlg = this;
	m_NumThreads = 0;
	m_Trigger = false;

	CoInitializeEx(NULL,COINIT_MULTITHREADED);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//CDataGrid *grid = (CDBGrid *)	this->GetDlgItem(IDC_CAMLIST);
	// read defaults
	m_FrameRate = AfxGetApp()->GetProfileInt("KeckController", "m_FrameRate", 30);
	m_FrameCount = AfxGetApp()->GetProfileInt("KeckController", "m_FrameCount", 1);
	m_PauseTime = AfxGetApp()->GetProfileInt("KeckController", "m_PauseTime", 0);
	UpdateData(FALSE);

	AddMessage("Connecting to Cameras ...");
	m_RigList.InsertColumn(1,"Rig",LVCFMT_LEFT,50);
	m_RigList.InsertColumn(2,"Status",LVCFMT_LEFT,235);
	for (int i = 0; i < NUM_RIGS; i++)
	{
		char srvName[10];
		sprintf(srvName,"Keck%02d",i);
		m_RigList.InsertItem(i,srvName);
		m_RigList.SetItemText(i,1,"Connecting...");
		int *cam = new int;
		*cam = i;
		AfxBeginThread(CamInit,cam);
	}

	m_CamList.AddString("Camera 0 (Grayscale)");
	m_CamList.AddString("Camera 1 (Grayscale)");
	m_CamList.AddString("Camera 2 (Grayscale)");
	m_CamList.AddString("Camera 3 (Color)");

	OnChangeFrameRate();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKeckControllerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeckControllerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeckControllerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CKeckControllerDlg::OnDestroy() 
{
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("KeckController", "m_FrameRate", m_FrameRate);
	AfxGetApp()->WriteProfileInt("KeckController", "m_FrameCount", m_FrameCount);
	AfxGetApp()->WriteProfileInt("KeckController", "m_PauseTime", m_PauseTime);

	CoUninitialize();

	CDialog::OnDestroy();
}

// append the printf style message to the m_messagesList listbox
void CKeckControllerDlg::AddMessage(char *fmt, ...)
{
	va_list args;   
	va_start(args, fmt);
	CString str;
	str.FormatV(fmt, args);
	int k = m_Messages.AddString(str);
	m_Messages.SetCurSel(k);
	va_end(args);
}

void CKeckControllerDlg::OnCapture() 
{
	UpdateData();

	CString s;
	m_Capture.GetWindowText(s);
	if (s == "&Capture") 
	{
		if (m_CamList.GetSelCount()*m_FrameCount>3000)
		{
			if (::MessageBox(m_hWnd,"You have specified more than 3000 total frames per rig. Continuing could lead to impending doom. Do you wish to continue?","Capture",MB_YESNO) == IDNO)
				return;
		}

		AddMessage("Opening Cameras ...");
		m_Capture.SetWindowText("&Go");
		m_RigList.EnableWindow(false);
		m_CamList.EnableWindow(false);
		m_Close.EnableWindow();
		m_Display.EnableWindow(false);
		m_Focus.EnableWindow(false);
		m_FrameCountEdit.EnableWindow(false);

		int i;

		for (i = 0; i < NUM_CAMS; i++)
			m_CamArray[i] = m_CamList.GetSel(i);

		int rigsel=0;
		for (i = 0; i < m_RigList.GetItemCount(); i++)
			if ((m_RigList.GetItemText(i,1) == "Ready.") && (m_RigList.GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED))
				rigsel++;
		if ((m_CamList.GetSelCount() == 0)||(rigsel == 0))
		{
			AddMessage("ERROR: No Valid Cameras Selected.");
			m_Capture.SetWindowText("&Capture");
			m_RigList.EnableWindow();
			m_CamList.EnableWindow();
			m_Close.EnableWindow(false);
			m_Display.EnableWindow();
			m_Focus.EnableWindow();
			m_FrameCountEdit.EnableWindow();
		}
		else
		{
			for (i = 0; i < m_RigList.GetItemCount(); i++)
				if ((m_RigList.GetItemText(i,1) == "Ready.") && (m_RigList.GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED))
				{
					int *cam = new int;
					*cam = i;
					AfxBeginThread(CamCapt,cam);
				}
		}
	}
	else
	{
		m_Capture.EnableWindow(false);

		if (m_PauseTime > 0) {
			Sleep(m_PauseTime * 1000);
		}
		Beep(1000, 500);
		AddMessage("Starting Capture ...");

		StartTrigger();
	}
}

void CKeckControllerDlg::OnSave() 
{
	CSeqSaveDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		AddMessage("Starting Save ...");
		m_Close.EnableWindow(false);

		m_SeqName = dlg.m_FullName.Left(dlg.m_FullName.GetLength()-11);

		for (int i = 0; i < m_RigList.GetItemCount(); i++)
			if ((m_RigList.GetItemText(i,1) == "Captured.") && (m_RigList.GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED))
			{
				int *cam = new int;
				*cam = i+16*dlg.m_Type;
				AfxBeginThread(CamSave,cam);
			}
	}
}

void CKeckControllerDlg::OnDisplay() 
{
	UpdateData();

	CString s;
	m_Display.GetWindowText(s);
	if (s == "&Display...") 
	{
		CCamSelDlg dlg;
		dlg.m_All = true;
		if (dlg.DoModal() == IDOK)
		{
			int rig,cam;
			if ((rig = dlg.m_Rig) == LB_ERR)
				return;
			if ((cam = dlg.m_Cam) == LB_ERR)
				return;
			if ((m_Mode = dlg.m_Mode) == LB_ERR)
				return;
			int *n = new int;

			char msg[100];
			sprintf(msg,"Displaying live images from keck%02d (cam %d) ...",rig,cam);
			AddMessage(msg);
			m_Display.SetWindowText("S&top");
			m_Capture.EnableWindow(false);
			m_Focus.EnableWindow(false);

			*n = rig*NUM_CAMS+cam;
			AfxBeginThread(CamLive,n);

			StartTrigger();
		}
	}
	else
	{
		m_Display.SetWindowText("&Display...");
		m_Display.EnableWindow(false);
	}
}

void CKeckControllerDlg::OnPlay() 
{
	CString s;
	m_Play.GetWindowText(s);
	if (s == "&Play...") 
	{
		CCamSelDlg dlg;
		dlg.m_All = false;
		if (dlg.DoModal() == IDOK)
		{
			int rig,cam;
			if ((rig = dlg.m_Rig) == LB_ERR)
				return;
			if ((cam = dlg.m_Cam) == LB_ERR)
				return;
			if ((m_Mode = dlg.m_Mode) == LB_ERR)
				return;

			char msg[100];
			sprintf(msg,"Playing sequence from keck%02d (cam %d) ...",rig,cam);
			AddMessage(msg);
			m_Play.SetWindowText("S&top");
			m_Close.EnableWindow(false);

			int *n = new int;
			*n = rig*NUM_CAMS+cam;
			AfxBeginThread(CamPlay,n);
		}
	}
	else
	{
		m_Play.SetWindowText("&Play...");
		m_Play.EnableWindow(false);
	}
}

void CKeckControllerDlg::OnClose() 
{
	StopTrigger();

	AddMessage("Closing Cameras ...");
	m_Close.EnableWindow(false);

	for (int i = 0; i < m_RigList.GetItemCount(); i++)
		if ((theDlg->m_RigList.GetItemText(i,1) == "Captured.") && (m_RigList.GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED))
		{
			int *cam = new int;
			*cam = i;
			AfxBeginThread(CamClose,cam);
		}
}

void CKeckControllerDlg::OnFocus() 
{
	UpdateData();

	CString s;
	m_Focus.GetWindowText(s);
	if (s == "F&ocus") 
	{
		AddMessage("Focusing Cameras ...");
		int rigsel=0;
		for (int i = 0; i < m_RigList.GetItemCount(); i++)
			if ((m_RigList.GetItemText(i,1) == "Ready.") && (m_RigList.GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED))
				rigsel++;
		if ((m_CamList.GetSelCount() == 0)||(rigsel == 0))
		{
			AddMessage("ERROR: No Valid Cameras Selected.");
			return;
		}
		m_Focus.SetWindowText("S&top");
		m_Capture.EnableWindow(false);
		m_Display.EnableWindow(false);
		m_RigList.EnableWindow(false);
		m_CamList.EnableWindow(false);

		AfxBeginThread(CamFocus,NULL);
	}
	else
	{
		m_Focus.SetWindowText("F&ocus");
		m_Focus.EnableWindow(false);
	}
}

void CKeckControllerDlg::OnSettings() 
{
	char path[100];
	_getcwd(path,100);
	char cmd[200];
	sprintf(cmd,"%s\\ES-310.ht",path);

	ShellExecute(m_hWnd,"open",cmd,"",path,SW_SHOW);
}

void CKeckControllerDlg::OnTrigger() 
{
	if (m_TriggerBox.GetCheck())
		StartTrigger();
	else
		StopTrigger();
}

void CKeckControllerDlg::OnChangeFrameRate() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();

	if (m_FrameRate <= 30)
		strcpy(m_DcfName, "es310_30.dcf");
	else
		strcpy(m_DcfName, "es310_60.dcf");

	if (m_Trigger)
	{
		StopTrigger();
		StartTrigger();
	}
}

CString GetLastErrorMessage()
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	CString error = (char *)lpMsgBuf;
	LocalFree( lpMsgBuf );
	return error;
}

UINT CamInit( LPVOID pParam )
{
	int cam = *(int*)pParam;
	delete pParam;

	HRESULT hr;
	COSERVERINFO server;
	MULTI_QI qi;
	char srvName[10];

	memset(&server, 0, sizeof(server));
	sprintf(srvName,"Keck%02d",cam);
	server.pwszName = _bstr_t(srvName);

	memset(&qi, 0, sizeof(qi)); 
	qi.pIID = &IID_ICamera;

	hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
	hr = CoCreateInstanceEx(CLSID_Camera, NULL, CLSCTX_SERVER, &server,1,&qi);

	if (SUCCEEDED(hr))
	{
		theDlg->m_Cameras[cam] = (ICamera *)qi.pItf;
		theDlg->m_RigList.SetItemText(cam,1,"Ready.");
	}
	else
	{
		theDlg->m_Cameras[cam] = NULL;
		theDlg->m_RigList.SetItemText(cam,1,"Error.");
		_com_error e(hr);
		char str[80];
		sprintf(str,"Error connecting to Keck%02d: %s",cam,e.ErrorMessage());
		theDlg->AddMessage(str);
	}

	CoUninitialize();

	return 0;
}

UINT CamFocus( LPVOID pParam )
{
    HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	unsigned char image[644*484];
	CVisRGBAByteImage I(WIDTH,HEIGHT);
	CVisPane P;
	CString s;

	theDlg->StartTrigger();

	for (int rig = 0; rig < theDlg->m_RigList.GetItemCount(); rig++)
		if ((theDlg->m_RigList.GetItemText(rig,1) == "Ready.") && (theDlg->m_RigList.GetItemState(rig,LVIS_SELECTED) == LVIS_SELECTED))
		{
			theDlg->m_RigList.SetItemText(rig,1,"Focusing...");
			for (int cam = 0; cam < NUM_CAMS; cam++)
				if (theDlg->m_CamList.GetSel(cam))
				{
					hr = theDlg->m_Cameras[rig]->SetDcfFile((unsigned char *)theDlg->m_DcfName);	

					theDlg->m_Focus.GetWindowText(s);
					char title[50];
					sprintf(title,"Keck%02d - Cam %d (Focusing)",rig,cam);

					long max = 0;
					long min = 999999999;
					long prev = 0;
					long curr = 0;
					while ((s == "S&top") && SUCCEEDED(hr))
					{
						hr = theDlg->m_Cameras[rig]->GetLiveImage(cam,image);
						if (FAILED(hr))
						{
							_com_error e(hr);
							char str[200];
							sprintf(str,"Error displaying live images from Keck%02d: %s",rig,e.ErrorMessage());
							theDlg->AddMessage(str);
						}
						else
						{
							prev = curr;
							curr = Contrast(image);
							max=max(curr,max);
							min=min(curr,min);
							if (curr < prev/2)
							{
								Beep(1000,500);
								break;
							}
							Beep(250+500*(curr+1)/(max+1),100);
							sprintf(title,"Keck%02d - Cam %d (Focusing - %d)",rig,cam,100*(curr+1)/(max+1));
							P.Display(Gray644x484(image));
							P.SetTitle(title);
							P.Refresh(true);
						}
						theDlg->m_Focus.GetWindowText(s);
					}
				}
			theDlg->m_RigList.SetItemText(rig,1,"Ready.");
		}

	theDlg->StopTrigger();

	theDlg->AddMessage("... Finished Focusing.");
	theDlg->m_Focus.SetWindowText("F&ocus");
	theDlg->m_Focus.EnableWindow();
	theDlg->m_Capture.EnableWindow();
	theDlg->m_Display.EnableWindow();
	theDlg->m_RigList.EnableWindow();
	theDlg->m_CamList.EnableWindow();

	CoUninitialize();

	return 0;
}

UINT CamLive( LPVOID pParam )
{
	int * n = (int *) pParam;
	int rig = *n/NUM_CAMS;
	int cam = *n%NUM_CAMS;
	delete n;

    HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	theDlg->m_RigList.SetItemText(rig,1,"Displaying...");
	hr = theDlg->m_Cameras[rig]->SetDcfFile((unsigned char *)theDlg->m_DcfName);

	unsigned char image[644*484];
	CVisRGBAByteImage I(WIDTH,HEIGHT);
	CVisPane P;
	CString s;
	theDlg->m_Display.GetWindowText(s);
	char title[50];
	sprintf(title,"Keck%02d - Cam %d (Live)",rig,cam);
	while ((s == "S&top") && SUCCEEDED(hr))
	{
		hr = theDlg->m_Cameras[rig]->GetLiveImage(cam,image);
		if (FAILED(hr))
		{
			_com_error e(hr);
			char str[200];
			sprintf(str,"Error displaying live images from Keck%02d: %s",rig,e.ErrorMessage());
			theDlg->AddMessage(str);
		}
		else
		{
			switch(theDlg->m_Mode)
			{
			case 0:
				P.Display(Gray644x484(image));
				break;
			case 1:
				P.Display(Gray322x242(image));
				break;
			case 2:
				if (cam==3)
					P.Display(Color322x242(image));
				else
					P.Display(Gray322x242(image));
				break;
			case 3:
				if (cam==3)
					P.Display(Color644x484(image));
				else
					P.Display(Gray644x484(image));
				break;
			case 4:
				if (cam==3)
					P.Display(ColorBal322x242(image));
				else
					P.Display(Gray322x242(image));
				break;
			case 5:
				if (cam==3)
					P.Display(ColorBal644x484(image));
				else
					P.Display(Gray644x484(image));
				break;
			}
			P.SetTitle(title);
			P.Refresh(true);
		}
		theDlg->m_Display.GetWindowText(s);
	}

	theDlg->StopTrigger();

	theDlg->AddMessage("... Finished Displaying.");
	theDlg->m_RigList.SetItemText(rig,1,"Ready.");
	theDlg->m_Display.SetWindowText("&Display...");
	theDlg->m_Display.EnableWindow();
	theDlg->m_Capture.EnableWindow();
	theDlg->m_Focus.EnableWindow();

	CoUninitialize();

	return 0;
}

UINT CamCapt( LPVOID pParam )
{
	theDlg->m_NumThreads++;

	int cam = *(int*)pParam;
	delete pParam;

	HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	theDlg->m_RigList.SetItemText(cam,1,"Opening...");
	hr = theDlg->m_Cameras[cam]->SetDcfFile((unsigned char *)theDlg->m_DcfName);
	hr = theDlg->m_Cameras[cam]->AllocBuffer(theDlg->m_CamArray,theDlg->m_FrameCount);
	if (SUCCEEDED(hr))
	{
		theDlg->m_RigList.SetItemText(cam,1,"Capturing...");
		hr = theDlg->m_Cameras[cam]->StartCapture();
		if (SUCCEEDED(hr))
		{
			theDlg->m_RigList.SetItemText(cam,1,"Captured.");
		}
		else
		{
			_com_error e(hr);
			char str[80];
			sprintf(str,"Error capturing on Keck%02d: %s",cam,e.ErrorMessage());
			theDlg->AddMessage(str);
			theDlg->m_RigList.SetItemText(cam,1,"Ready.");
		}
	}
	else
	{
		_com_error e(hr);
		char str[80];
		sprintf(str,"Error opening cameras on Keck%02d: %s",cam,e.ErrorMessage());
		theDlg->AddMessage(str);
		theDlg->m_RigList.SetItemText(cam,1,"Ready.");
	}

	CoUninitialize();

	theDlg->m_NumThreads--;

	if (theDlg->m_NumThreads == 0)
	{
		theDlg->StopTrigger();

		theDlg->AddMessage("... Finished Capturing.");
		Beep(500, 500);
		theDlg->m_Capture.SetWindowText("&Capture");
		theDlg->m_Capture.EnableWindow(false);
		theDlg->m_Play.EnableWindow(true);
		theDlg->m_Save.EnableWindow(true);
	}

	return 0;
}

UINT CamPlay( LPVOID pParam )
{
	int * n = (int *) pParam;
	int rig = *n/NUM_CAMS;
	int cam = *n%NUM_CAMS;
	delete n;

    HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	theDlg->m_RigList.SetItemText(rig,1,"Playing...");

	unsigned char image[644*484];
	CVisByteImage I(WIDTH,HEIGHT);
	CVisPane P;
	CString s;
	theDlg->m_Play.GetWindowText(s);
	for (int i = 0; SUCCEEDED(hr)&&(i < theDlg->m_FrameCount)&&(s=="S&top"); i++)
	{
		hr = theDlg->m_Cameras[rig]->GetCapturedImage(cam,i,image);
		if (FAILED(hr))
		{
			_com_error e(hr);
			char str[200];
			sprintf(str,"Error playing sequence from Keck%02d: %s",rig,e.ErrorMessage());
			theDlg->AddMessage(str);
		}
		else
		{
			switch(theDlg->m_Mode)
			{
			case 0:
				P.Display(Gray644x484(image));
				break;
			case 1:
				P.Display(Gray322x242(image));
				break;
			case 2:
				if (cam==3)
					P.Display(Color322x242(image));
				else
					P.Display(Gray322x242(image));
				break;
			case 3:
				if (cam==3)
					P.Display(Color644x484(image));
				else
					P.Display(Gray644x484(image));
				break;
			case 4:
				if (cam==3)
					P.Display(ColorBal322x242(image));
				else
					P.Display(Gray322x242(image));
				break;
			case 5:
				if (cam==3)
					P.Display(ColorBal644x484(image));
				else
					P.Display(Gray644x484(image));
				break;
			}
			char title[50];
			sprintf(title,"Keck%02d - Cam %d (Playing %d of %d)",rig,cam,i,theDlg->m_FrameCount);
			P.SetTitle(title);
			P.Refresh(true);
		}
		theDlg->m_Play.GetWindowText(s);
	}

	theDlg->AddMessage("... Finished Playing.");
	theDlg->m_RigList.SetItemText(rig,1,"Captured.");
	theDlg->m_Play.SetWindowText("&Play...");
	theDlg->m_Play.EnableWindow();
	theDlg->m_Close.EnableWindow();

	CoUninitialize();

	return 0;
}

UINT CamSave( LPVOID pParam )
{
	theDlg->m_NumThreads++;

	int cam = (*(int*)pParam)%16;
	int type = (*(int*)pParam)/16;
	delete pParam;

	HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	theDlg->m_RigList.SetItemText(cam,1,"Saving...");

	char fname[100];
	strcpy(fname,theDlg->m_SeqName);
	hr = theDlg->m_Cameras[cam]->SaveCapturedSeq(type,(unsigned char *)fname);

	if (FAILED(hr))
	{
		_com_error e(hr);
		char str[80];
		sprintf(str,"Error saving on Keck%02d: %s",cam,e.ErrorMessage());
		theDlg->AddMessage(str);
	}

	theDlg->m_RigList.SetItemText(cam,1,"Captured.");

	theDlg->m_NumThreads--;

	if (theDlg->m_NumThreads == 0)
	{
		theDlg->AddMessage("... Finished Saving.");
		theDlg->m_Close.EnableWindow();
	}

	CoUninitialize();

	return 0;
}

UINT CamClose( LPVOID pParam )
{
	theDlg->m_NumThreads++;

	int cam = *(int*)pParam;
	delete pParam;

	HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	theDlg->m_RigList.SetItemText(cam,1,"Closing...");

	hr = theDlg->m_Cameras[cam]->ReleaseBuffer();

	if (FAILED(hr))
	{
		_com_error e(hr);
		char str[80];
		sprintf(str,"Error closing cameras on Keck%02d: %s",cam,e.ErrorMessage());
		theDlg->AddMessage(str);
	}

	theDlg->m_RigList.SetItemText(cam,1,"Ready.");

	theDlg->m_NumThreads--;

	if (theDlg->m_NumThreads == 0)
	{
		theDlg->AddMessage("... Finished Closing Cameras.");
		theDlg->m_Capture.SetWindowText("&Capture");
		theDlg->m_RigList.EnableWindow();
		theDlg->m_CamList.EnableWindow();
		theDlg->m_Capture.EnableWindow();
		theDlg->m_Play.EnableWindow(false);
		theDlg->m_Save.EnableWindow(false);
		theDlg->m_Display.EnableWindow();
		theDlg->m_Focus.EnableWindow();
		theDlg->m_FrameCountEdit.EnableWindow();
	}

	CoUninitialize();

	return 0;
}

void CKeckControllerDlg::StartTrigger()
{
	if (!m_Trigger)
	{
#ifdef OLDAAPI
		// Get first available Open Layers board 
		CHECKERROR2 (olDaInitialize("Board1", &hdrvr));

		// get handle to CT sub system 
		CHECKERROR2 (olDaGetDASS(hdrvr, OLSS_CT, 4, &ct_ss));
		CHECKERROR2 (olDaGetDASS(hdrvr, OLSS_CT, 6, &ct_ss2));

		// setup internally cascaded clock
		olDaSetCascadeMode(ct_ss, OL_CT_CASCADE);
		olDaSetCascadeMode(ct_ss2, OL_CT_CASCADE);

		// specify internal CT clock input source
		CHECKERROR2 (olDaSetClockSource(ct_ss, OL_CLK_INTERNAL));
		CHECKERROR2 (olDaSetClockSource(ct_ss2, OL_CLK_INTERNAL));

		// specify gate type
		CHECKERROR2 (olDaSetGateType(ct_ss, OL_GATE_NONE));
		CHECKERROR2 (olDaSetGateType(ct_ss2, OL_GATE_NONE));

		// specify frequency of CT clock output
		CHECKERROR2 (olDaSetClockFrequency(ct_ss, (double)m_FrameRate));
		CHECKERROR2 (olDaSetClockFrequency(ct_ss2, (double)m_FrameRate));

		// setup for rate generation
		CHECKERROR2 (olDaSetCTMode(ct_ss, OL_CTMODE_RATE));
		CHECKERROR2 (olDaSetCTMode(ct_ss2, OL_CTMODE_RATE));

		// specify polarity of output pulses
		CHECKERROR2 (olDaSetPulseType(ct_ss, OL_PLS_HIGH2LOW));
		CHECKERROR2 (olDaSetPulseType(ct_ss2, OL_PLS_HIGH2LOW));

		// specify pulse width
		CHECKERROR2 (olDaSetPulseWidth(ct_ss, 95.00));
		CHECKERROR2 (olDaSetPulseWidth(ct_ss2, 95.00));

		// configure the system
		CHECKERROR2 (olDaConfig(ct_ss));
		CHECKERROR2 (olDaConfig(ct_ss2));

		// start signal generator
		CHECKERROR2 (olDaStart(ct_ss));
		CHECKERROR2 (olDaStart(ct_ss2));
#endif
		m_Trigger = true;
	}
	m_TriggerBox.SetCheck(true);
}

void CKeckControllerDlg::StopTrigger()
{
	if (m_Trigger)
	{
#ifdef OLDAAPI
		// stop signal generator
		CHECKERROR2 (olDaStop(ct_ss));
		CHECKERROR2 (olDaStop(ct_ss2));

		// Release handle to CT sub system 
		CHECKERROR2 (olDaReleaseDASS(ct_ss));
		CHECKERROR2 (olDaReleaseDASS(ct_ss2));

		// Release first available Open Layers board 
		CHECKERROR2 (olDaTerminate(hdrvr));
#endif
		m_Trigger = false;
	}
	m_TriggerBox.SetCheck(false);
}
