// KeckControllerDlg.h : header file
//

#ifdef OLDAAPI
#include <olmem.h>         
#include <olerrors.h>         
#include <oldaapi.h>
#endif

#if !defined(AFX_KECKCONTROLLERDLG_H__B4E180E1_9153_11D2_9160_00C04F79E903__INCLUDED_)
#define AFX_KECKCONTROLLERDLG_H__B4E180E1_9153_11D2_9160_00C04F79E903__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <VisCore.h>
#include "VisDisplay.h"

#include "..\KeckServer\KeckServer.h"

#define NUM_RIGS 16
#define NUM_CAMS 4

#define HEIGHT  484
#define WIDTH	644

#define FMT_TIF 0
#define FMT_PGM 1


/////////////////////////////////////////////////////////////////////////////
// CKeckControllerDlg dialog

class CKeckControllerDlg : public CDialog
{
	friend UINT CamInit( LPVOID pParam );
	friend UINT CamFocus( LPVOID pParam );
	friend UINT CamLive( LPVOID pParam );
	friend UINT CamCapt( LPVOID pParam );
	friend UINT CamPlay( LPVOID pParam );
	friend UINT CamSave( LPVOID pParam );
	friend UINT CamClose( LPVOID pParam );

// Construction
public:
	CKeckControllerDlg(CWnd* pParent = NULL);	// standard constructor
	void AddMessage(char *fmt, ...);

	ICamera *m_Cameras[NUM_RIGS];
	BOOL m_CamArray[NUM_CAMS];
	char m_DcfName[20];
	CString m_SeqName;
	int m_NumThreads;

	void StartTrigger();
	void StopTrigger();
	bool m_Trigger;
	int m_Mode;

#ifdef OLDAAPI
	HDEV hdrvr;
	ECODE status;
	HDASS ct_ss;
	HDASS ct_ss2;
	CString boardEntry;
	CString boardName;
#endif

// Dialog Data
	//{{AFX_DATA(CKeckControllerDlg)
	enum { IDD = IDD_KECKCONTROLLER_DIALOG };
	CButton	m_TriggerBox;
	CButton	m_Settings;
	CButton	m_Focus;
	CEdit	m_FrameCountEdit;
	CButton	m_Save;
	CButton	m_Play;
	CButton	m_Display;
	CButton	m_Close;
	CListCtrl	m_RigList;
	CListBox	m_CamList;
	CListBox	m_Messages;
	CButton	m_Capture;
	UINT	m_FrameRate;
	UINT	m_FrameCount;
	UINT	m_PauseTime;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeckControllerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CKeckControllerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCapture();
	afx_msg void OnDestroy();
	afx_msg void OnSave();
	afx_msg void OnDisplay();
	afx_msg void OnPlay();
	afx_msg void OnClose();
	afx_msg void OnChangeFrameRate();
	afx_msg void OnFocus();
	afx_msg void OnSettings();
	afx_msg void OnTrigger();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KECKCONTROLLERDLG_H__B4E180E1_9153_11D2_9160_00C04F79E903__INCLUDED_)
