// Camera.h : Declaration of the CCamera

#ifndef __CAMERA_H_
#define __CAMERA_H_

#include "resource.h"       // main symbols

void InitCameras();
void CloseCameras();

/////////////////////////////////////////////////////////////////////////////
// CCamera
class ATL_NO_VTABLE CCamera : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCamera, &CLSID_Camera>,
	public IDispatchImpl<ICamera, &IID_ICamera, &LIBID_KECKSERVERLib>
{
public:
	CCamera()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CAMERA)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCamera)
	COM_INTERFACE_ENTRY(ICamera)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICamera
public:
	STDMETHOD(SetDcfFile)(/*[in, string]*/ unsigned char *dcf);
	STDMETHOD(AllocBuffer)(/*[in]*/ BOOL cameras[4], /*[in]*/ long numFrames);
	STDMETHOD(ReleaseBuffer)();
	STDMETHOD(StartCapture)();
	STDMETHOD(SaveCapturedSeq)( /*[in]*/ long format, /*[in, string]*/ unsigned char *fileName);
	STDMETHOD(GetCapturedImage)(/*[in]*/ long cameraNumber, /*[in]*/ long imageNumber, /*[out]*/ unsigned char image[644*484]);
	STDMETHOD(GetLiveImage)(/*[in]*/ long cameraNumber, /*[out]*/ unsigned char image[644*484]);

	STDMETHOD(GetCamSettings)(/*[in]*/ long cameraNumber, /*[in]*/ long item, /*[out]*/ double *value);
	STDMETHOD(SetCamSettings)(/*[in]*/ long cameraNumber, /*[in]*/ long item, /*[in]*/ double value);
};

#endif //__CAMERA_H_
