// Trigger.h : Declaration of the CTrigger

#ifndef __TRIGGER_H_
#define __TRIGGER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTrigger

void InitTrigger();
void CloseTrigger();

class ATL_NO_VTABLE CTrigger : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTrigger, &CLSID_Trigger>,
	public IDispatchImpl<ITrigger, &IID_ITrigger, &LIBID_KECKTRIGGERLib>
{
public:
	CTrigger()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TRIGGER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTrigger)
	COM_INTERFACE_ENTRY(ITrigger)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ITrigger
public:
	STDMETHOD(Beep)(/*[in]*/ long Freq, /*[in]*/ long Len);
	STDMETHOD(GetStatus)(/*[out]*/ BOOL *status);
	STDMETHOD(StopTrigger)();
	STDMETHOD(StartTrigger)();
	STDMETHOD(SetRate)(/*[in]*/ long rate);
};

#endif //__TRIGGER_H_
